"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _SpacingFuncContext = require("./SpacingFuncContext");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const Box = _ref => {
  let {
    h,
    minH,
    maxH,
    w,
    minW,
    maxW,
    m,
    mt,
    mr,
    mb,
    ml,
    ms,
    me,
    mh,
    mv,
    p,
    pt,
    pr,
    pb,
    pl,
    ps,
    pe,
    ph,
    pv,
    style,
    ...rest
  } = _ref;
  const height = (0, _SpacingFuncContext.useSpacing)(h);
  const minHeight = (0, _SpacingFuncContext.useSpacing)(minH);
  const maxHeight = (0, _SpacingFuncContext.useSpacing)(maxH);
  const width = (0, _SpacingFuncContext.useSpacing)(w);
  const minWidth = (0, _SpacingFuncContext.useSpacing)(minW);
  const maxWidth = (0, _SpacingFuncContext.useSpacing)(maxW);
  const margin = (0, _SpacingFuncContext.useSpacing)(m);
  const marginTop = (0, _SpacingFuncContext.useSpacing)(mt);
  const marginRight = (0, _SpacingFuncContext.useSpacing)(mr);
  const marginBottom = (0, _SpacingFuncContext.useSpacing)(mb);
  const marginLeft = (0, _SpacingFuncContext.useSpacing)(ml);
  const marginStart = (0, _SpacingFuncContext.useSpacing)(ms);
  const marginEnd = (0, _SpacingFuncContext.useSpacing)(me);
  const marginHorizontal = (0, _SpacingFuncContext.useSpacing)(mh);
  const marginVertical = (0, _SpacingFuncContext.useSpacing)(mv);
  const padding = (0, _SpacingFuncContext.useSpacing)(p);
  const paddingTop = (0, _SpacingFuncContext.useSpacing)(pt);
  const paddingRight = (0, _SpacingFuncContext.useSpacing)(pr);
  const paddingBottom = (0, _SpacingFuncContext.useSpacing)(pb);
  const paddingLeft = (0, _SpacingFuncContext.useSpacing)(pl);
  const paddingStart = (0, _SpacingFuncContext.useSpacing)(ps);
  const paddingEnd = (0, _SpacingFuncContext.useSpacing)(pe);
  const paddingHorizontal = (0, _SpacingFuncContext.useSpacing)(ph);
  const paddingVertical = (0, _SpacingFuncContext.useSpacing)(pv);
  const boxStyle = (0, _react.useMemo)(() => ({
    height,
    minHeight,
    maxHeight,
    width,
    minWidth,
    maxWidth,
    margin,
    marginTop,
    marginRight,
    marginBottom,
    marginLeft,
    marginStart,
    marginEnd,
    marginHorizontal,
    marginVertical,
    padding,
    paddingTop,
    paddingRight,
    paddingBottom,
    paddingLeft,
    paddingStart,
    paddingEnd,
    paddingHorizontal,
    paddingVertical
  }), [height, minHeight, maxHeight, width, minWidth, maxWidth, margin, marginTop, marginRight, marginBottom, marginLeft, marginStart, marginEnd, marginHorizontal, marginVertical, padding, paddingTop, paddingRight, paddingBottom, paddingLeft, paddingStart, paddingEnd, paddingHorizontal, paddingVertical]);
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, _extends({
    style: [boxStyle, style]
  }, rest));
};

var _default = Box;
exports.default = _default;
//# sourceMappingURL=Box.js.map