"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getValidChildren = getValidChildren;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Gets only the valid children of a component,
 * and ignores any nullish or falsy child.
 *
 * @param children the children
 */
function getValidChildren(children) {
  return _react.default.Children.toArray(children).filter(child => /*#__PURE__*/_react.default.isValidElement(child));
}
//# sourceMappingURL=utilities.js.map