function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React, { useMemo } from 'react';
import { View } from 'react-native';
import { useSpacing } from './SpacingFuncContext';

const Box = _ref => {
  let {
    h,
    minH,
    maxH,
    w,
    minW,
    maxW,
    m,
    mt,
    mr,
    mb,
    ml,
    ms,
    me,
    mh,
    mv,
    p,
    pt,
    pr,
    pb,
    pl,
    ps,
    pe,
    ph,
    pv,
    style,
    ...rest
  } = _ref;
  const height = useSpacing(h);
  const minHeight = useSpacing(minH);
  const maxHeight = useSpacing(maxH);
  const width = useSpacing(w);
  const minWidth = useSpacing(minW);
  const maxWidth = useSpacing(maxW);
  const margin = useSpacing(m);
  const marginTop = useSpacing(mt);
  const marginRight = useSpacing(mr);
  const marginBottom = useSpacing(mb);
  const marginLeft = useSpacing(ml);
  const marginStart = useSpacing(ms);
  const marginEnd = useSpacing(me);
  const marginHorizontal = useSpacing(mh);
  const marginVertical = useSpacing(mv);
  const padding = useSpacing(p);
  const paddingTop = useSpacing(pt);
  const paddingRight = useSpacing(pr);
  const paddingBottom = useSpacing(pb);
  const paddingLeft = useSpacing(pl);
  const paddingStart = useSpacing(ps);
  const paddingEnd = useSpacing(pe);
  const paddingHorizontal = useSpacing(ph);
  const paddingVertical = useSpacing(pv);
  const boxStyle = useMemo(() => ({
    height,
    minHeight,
    maxHeight,
    width,
    minWidth,
    maxWidth,
    margin,
    marginTop,
    marginRight,
    marginBottom,
    marginLeft,
    marginStart,
    marginEnd,
    marginHorizontal,
    marginVertical,
    padding,
    paddingTop,
    paddingRight,
    paddingBottom,
    paddingLeft,
    paddingStart,
    paddingEnd,
    paddingHorizontal,
    paddingVertical
  }), [height, minHeight, maxHeight, width, minWidth, maxWidth, margin, marginTop, marginRight, marginBottom, marginLeft, marginStart, marginEnd, marginHorizontal, marginVertical, padding, paddingTop, paddingRight, paddingBottom, paddingLeft, paddingStart, paddingEnd, paddingHorizontal, paddingVertical]);
  return /*#__PURE__*/React.createElement(View, _extends({
    style: [boxStyle, style]
  }, rest));
};

export default Box;
//# sourceMappingURL=Box.js.map