import React from 'react';
import type { BoxProps } from './Box';
export interface DividerProps extends BoxProps {
    /**
     * The orientation of the divider.
     *
     * @default 'horizontal'
     */
    orientation?: 'horizontal' | 'vertical';
    /**
     * The thickness of the divider.
     *
     * @default 1
     */
    thickness?: number;
    /**
     * The color of the divider.
     *
     * @default '#E0E0E0'
     */
    color?: string;
}
declare const Divider: React.FC<DividerProps>;
export default Divider;
