import React from 'react';
import type { ImageStyle, StyleProp, TextStyle, ViewStyle } from 'react-native';
declare type Style = StyleProp<ViewStyle | TextStyle | ImageStyle>;
declare type ChildrenStyle = Style | ((index: number, length: number) => Style);
declare type ChildrenStyleProp = ChildrenStyle | Array<ChildrenStyleProp>;
export interface SelectorProps {
    /**
     * A style object to apply to each child.
     */
    childrenStyle?: ChildrenStyleProp;
}
declare const Selector: React.FC<SelectorProps>;
export default Selector;
export declare const select: (selector: (index: number, length: number) => boolean) => (style: Style) => (index: number, length: number) => Style;
export declare const firstChild: (style: Style) => (index: number, length: number) => Style;
export declare const notFirstChild: (style: Style) => (index: number, length: number) => Style;
export declare const lastChild: (style: Style) => (index: number, length: number) => Style;
export declare const notLastChild: (style: Style) => (index: number, length: number) => Style;
export declare const even: (style: Style) => (index: number, length: number) => Style;
export declare const odd: (style: Style) => (index: number, length: number) => Style;
