import React from 'react';
import { StyleProp, ViewStyle } from 'react-native';
import type { FlexProps } from './Flex';
import type { SelectorProps } from './Selector';
export interface StackProps extends FlexProps, SelectorProps {
    /**
     * The spacing between items in the stack.
     *
     * @default 0
     */
    spacing?: number;
    /**
     * If `true`, each stack item will show a divider.
     *
     * @default false
     */
    divider?: React.ReactElement;
    /**
     * The style of the divider.
     */
    dividerStyle?: StyleProp<ViewStyle>;
    /**
     * If `true`, the children will be wrapped in a `Box` and the `Box` will take the spacing properties.
     *
     * @default false
     */
    shouldWrapChildren?: boolean;
}
declare const Stack: React.FC<StackProps>;
export default Stack;
export interface HStackProps extends Omit<StackProps, 'inline' | 'direction'> {
    reverse?: boolean;
}
export declare const HStack: React.FC<HStackProps>;
export interface VStackProps extends Omit<StackProps, 'inline' | 'direction'> {
    reverse?: boolean;
}
export declare const VStack: React.FC<VStackProps>;
