import React from 'react';
import type { FlexProps } from './Flex';
import type { SelectorProps } from './Selector';
export interface WrapProps extends FlexProps, SelectorProps {
    /**
     * The space between each child (even if it wraps).
     *
     * @default 0
     */
    spacing?: number;
    /**
     * If `true`, the children will be wrapped in a `Box` and the `Box` will take the spacing properties.
     *
     * @default false
     */
    shouldWrapChildren?: boolean;
}
declare const Wrap: React.FC<WrapProps>;
export default Wrap;
